/**
 *	 Jigsaw Puzzle 1.0fc1
 *	 Author: Soo-Im Jansson
 *	 Created: 2006-05-14, 22:05
 *
 *	 Copyright (C) 2006, Jigsaw Puzzle, all rights reserved.
 *
 * This software is free to use, provided that
 *    i) this copyright and warranty notice appear on all copies of
 *       the software;
 *   ii) this software is not utilized in a manner, which is
 *       disparaging to the author.
 *  iii) this software is not redistributed commercially.
 *
 * This software is provided "AS IS," without a warranty of any kind.
 * ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES,
 * INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED.
 * THE AUTHOR SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THE
 * SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL THE AUTHOR BE
 * LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES,
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING
 * OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF THE
 * AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */

// Global variables
var maxPieces=12;
var currentHighlightedGrid=0;
var currentHighlightedPiece=0;
var boardPositions=null;
var puzzlePositionsX=null;
var puzzlePositionsY=null;
var outerPositionsInUse=null;

function startPuzzle() {
        boardPositions=new Array();
	for (i=0; i<maxPieces; i++) {
		boardPositions.push(0);
	}
	NeutralGreenButton.visible=true;
	NeutralRedButton.visible=false;
	GreenButton.visible=false;
	RedButton.visible=true;
	initiatePuzzlePositions();
        shufflePuzzlePieces();
} // startPuzzle()

function endPuzzle() {
	NeutralGreenButton.visible=false;
	NeutralRedButton.visible=true;
	GreenButton.visible=true;
	RedButton.visible=false;
	puzzleStarted=false;
} // endPuzzle()

function initiatePuzzlePositions() {
	puzzlePositionsX=new Array();
	puzzlePositionsX.push(2);
	puzzlePositionsX.push(2);
	puzzlePositionsX.push(2);
	puzzlePositionsX.push(2);
	puzzlePositionsX.push(2);
	puzzlePositionsX.push(117);
	puzzlePositionsX.push(234);
	puzzlePositionsX.push(351);
	puzzlePositionsX.push(470);
	puzzlePositionsX.push(470);
	puzzlePositionsX.push(470);
	puzzlePositionsX.push(470);
	puzzlePositionsY=new Array();
	puzzlePositionsY.push(2);
	puzzlePositionsY.push(82);
	puzzlePositionsY.push(162);
	puzzlePositionsY.push(242);
	puzzlePositionsY.push(322);
	puzzlePositionsY.push(2);
	puzzlePositionsY.push(2);
	puzzlePositionsY.push(2);
	puzzlePositionsY.push(2);
	puzzlePositionsY.push(102);
	puzzlePositionsY.push(212);
	puzzlePositionsY.push(322);
} //  initiatePuzzlePositions()

function shufflePuzzlePieces() {
	outerPositionsInUse=new Array();
	outerPositionsInUse.push(0);
	outerPositionsInUse.push(1);
	outerPositionsInUse.push(2);
	outerPositionsInUse.push(3);
	outerPositionsInUse.push(4);
	outerPositionsInUse.push(5);
	outerPositionsInUse.push(6);
	outerPositionsInUse.push(7);
	outerPositionsInUse.push(8);
	outerPositionsInUse.push(9);
	outerPositionsInUse.push(10);
	outerPositionsInUse.push(11);
	// Randomly swap places
	for (i=0; i<maxPieces; i++) {
		swap1=random(0, maxPieces);
		temp1=outerPositionsInUse[swap1];
		swap2=random(0, maxPieces);
		temp2=outerPositionsInUse[swap2];
		outerPositionsInUse[swap1]=temp2;
		outerPositionsInUse[swap2]=temp1;
	}
	print("outerPositionsInUse="+outerPositionsInUse);
	for (j=0; j<maxPieces; j++) {
		var x=outerPositionsInUse[j];
		var y=outerPositionsInUse[j];
		switch(j+1) {
			case 1:
				Piece1.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 2:
				Piece2.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 3:
				Piece3.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 4:
				Piece4.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 5:
				Piece5.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 6:
				Piece6.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 7:
				Piece7.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 8:
				Piece8.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 9:
				Piece9.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 10:
				Piece10.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 11:
				Piece11.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
			case 12:
				Piece12.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 1);
				break;
		} // switch()
	} // for
} // shufflePuzzlePieces()

function highlightGrid(gridNumber) {
	GridHighlight.visible=false;
	currentHighlightedGrid=gridNumber;
	if (boardPositions[gridNumber-1] == 0) {
		switch(gridNumber) {
			case 1:
				GridHighlight.hOffset=Grid1.hOffset;
				GridHighlight.vOffset=Grid1.vOffset;
				GridHighlight.visible=true;
				break;
			case 2:
				GridHighlight.hOffset=Grid2.hOffset;
				GridHighlight.vOffset=Grid2.vOffset;
				GridHighlight.visible=true;
				break;
			case 3:
				GridHighlight.hOffset=Grid3.hOffset;
				GridHighlight.vOffset=Grid3.vOffset;
				GridHighlight.visible=true;
				break;
			case 4:
				GridHighlight.hOffset=Grid4.hOffset;
				GridHighlight.vOffset=Grid4.vOffset;
				GridHighlight.visible=true;
				break;
			case 5:
				GridHighlight.hOffset=Grid5.hOffset;
				GridHighlight.vOffset=Grid5.vOffset;
				GridHighlight.visible=true;
				break;
			case 6:
				GridHighlight.hOffset=Grid6.hOffset;
				GridHighlight.vOffset=Grid6.vOffset;
				GridHighlight.visible=true;
				break;
			case 7:
				GridHighlight.hOffset=Grid7.hOffset;
				GridHighlight.vOffset=Grid7.vOffset;
				GridHighlight.visible=true;
				break;
			case 8:
				GridHighlight.hOffset=Grid8.hOffset;
				GridHighlight.vOffset=Grid8.vOffset;
				GridHighlight.visible=true;
				break;
			case 9:
				GridHighlight.hOffset=Grid9.hOffset;
				GridHighlight.vOffset=Grid9.vOffset;
				GridHighlight.visible=true;
				break;
			case 10:
				GridHighlight.hOffset=Grid10.hOffset;
				GridHighlight.vOffset=Grid10.vOffset;
				GridHighlight.visible=true;
				break;
			case 11:
				GridHighlight.hOffset=Grid11.hOffset;
				GridHighlight.vOffset=Grid11.vOffset;
				GridHighlight.visible=true;
				break;
			case 12:
				GridHighlight.hOffset=Grid12.hOffset;
				GridHighlight.vOffset=Grid12.vOffset;
				GridHighlight.visible=true;
				break;
		} // switch()
	} // if
} // highlightGrid()

function highlightPiece(pieceNumber) {
	pieceHighlighted=false;
	PuzzleHighlight.visible=false;
	currentHighlightedPiece=pieceNumber;
	switch(pieceNumber) {
		case 1:
			PuzzleHighlight.hOffset=Piece1.hOffset-2;
			PuzzleHighlight.vOffset=Piece1.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 2:
			PuzzleHighlight.hOffset=Piece2.hOffset-2;
			PuzzleHighlight.vOffset=Piece2.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 3:
			PuzzleHighlight.hOffset=Piece3.hOffset-2;
			PuzzleHighlight.vOffset=Piece3.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 4:
			PuzzleHighlight.hOffset=Piece4.hOffset-2;
			PuzzleHighlight.vOffset=Piece4.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 5:
			PuzzleHighlight.hOffset=Piece5.hOffset-2;
			PuzzleHighlight.vOffset=Piece5.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 6:
			PuzzleHighlight.hOffset=Piece6.hOffset-2;
			PuzzleHighlight.vOffset=Piece6.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
 			break;
		case 7:
			PuzzleHighlight.hOffset=Piece7.hOffset-2;
			PuzzleHighlight.vOffset=Piece7.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 8:
			PuzzleHighlight.hOffset=Piece8.hOffset-2;
			PuzzleHighlight.vOffset=Piece8.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 9:
			PuzzleHighlight.hOffset=Piece9.hOffset-2;
			PuzzleHighlight.vOffset=Piece9.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 10:
			PuzzleHighlight.hOffset=Piece10.hOffset-2;
			PuzzleHighlight.vOffset=Piece10.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 11:
			PuzzleHighlight.hOffset=Piece11.hOffset-2;
			PuzzleHighlight.vOffset=Piece11.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
		case 12:
			PuzzleHighlight.hOffset=Piece12.hOffset-2;
			PuzzleHighlight.vOffset=Piece12.vOffset-2;
			pieceHighlighted=true;
			PuzzleHighlight.visible=true;
			break;
	} // switch()
} // highlightPiece()

function moveOutPiece(puzzlePieceNumber) {
	pieceHighlighted=false;
	PuzzleHighlight.visible=false;
	var x=outerPositionsInUse[puzzlePieceNumber-1];
	var y=outerPositionsInUse[puzzlePieceNumber-1];
	switch(puzzlePieceNumber) {
		case 1:
			Piece1.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 2:
			Piece2.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 3:
			Piece3.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 4:
			Piece4.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 5:
			Piece5.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 6:
			Piece6.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 7:
			Piece7.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 8:
			Piece8.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 9:
			Piece9.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 10:
			Piece10.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 11:
			Piece11.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
		case 12:
			Piece12.moveTo(puzzlePositionsX[x], puzzlePositionsY[y], 5);
			break;
	} // switch()
	for (i=0; i<maxPieces; i++) {
		if (boardPositions[i] == puzzlePieceNumber) {
			boardPositions[i]=0;
		}
	}
	print("boardPositions="+boardPositions);
}

function movePiece(currentPieceNumber, currentGridNumber) {
	print("outerPositionsInUse="+outerPositionsInUse);
	pieceHighlighted=false;
	PuzzleHighlight.visible=false;
	GridHighlight.visible=false;
	switch(currentPieceNumber) {
		case 1:
			switch(currentGridNumber) {
				case 1:
					Piece1.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece1.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece1.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece1.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece1.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece1.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece1.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece1.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece1.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece1.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece1.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece1.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 2:
			switch(currentGridNumber) {
				case 1:
					Piece2.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece2.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece2.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece2.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece2.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece2.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece2.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece2.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece2.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece2.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece2.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece2.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 3:
			switch(currentGridNumber) {
				case 1:
					Piece3.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece3.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece3.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece3.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece3.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece3.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece3.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece3.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece3.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece3.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece3.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece3.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 4:
			switch(currentGridNumber) {
				case 1:
					Piece4.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece4.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece4.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece4.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece4.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece4.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece4.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece4.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece4.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece4.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece4.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece4.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 5:
			switch(currentGridNumber) {
				case 1:
					Piece5.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece5.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece5.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece5.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece5.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece5.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece5.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece5.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece5.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece5.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece5.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece5.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 6:
			switch(currentGridNumber) {
				case 1:
					Piece6.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece6.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece6.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece6.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece6.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece6.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece6.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece6.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece6.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece6.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece6.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece6.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 7:
			switch(currentGridNumber) {
				case 1:
					Piece7.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece7.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece7.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece7.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece7.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece7.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece7.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece7.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece7.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece7.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece7.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece7.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 8:
			switch(currentGridNumber) {
				case 1:
					Piece8.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece8.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece8.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece8.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece8.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece8.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece8.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece8.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece8.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece8.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece8.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece8.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 9:
			switch(currentGridNumber) {
				case 1:
					Piece9.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece9.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece9.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece9.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece9.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece9.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece9.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece9.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece9.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece9.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece9.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece9.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 10:
			switch(currentGridNumber) {
				case 1:
					Piece10.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece10.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece10.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece10.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece10.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece10.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece10.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece10.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece10.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece10.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece10.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece10.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
		case 11:
			switch(currentGridNumber) {
				case 1:
					Piece11.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece11.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece11.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece11.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece11.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece11.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece11.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece11.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece11.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece11.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece11.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece11.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
 		case 12:
			switch(currentGridNumber) {
				case 1:
					Piece12.moveTo(Grid1.hOffset, Grid1.vOffset);
					break;
				case 2:
					Piece12.moveTo(Grid2.hOffset, Grid2.vOffset);
					break;
				case 3:
					Piece12.moveTo(Grid3.hOffset, Grid3.vOffset);
					break;
				case 4:
					Piece12.moveTo(Grid4.hOffset, Grid4.vOffset);
					break;
				case 5:
					Piece12.moveTo(Grid5.hOffset, Grid5.vOffset);
					break;
				case 6:
					Piece12.moveTo(Grid6.hOffset, Grid6.vOffset);
					break;
				case 7:
					Piece12.moveTo(Grid7.hOffset, Grid7.vOffset);
					break;
				case 8:
					Piece12.moveTo(Grid8.hOffset, Grid8.vOffset);
					break;
				case 9:
					Piece12.moveTo(Grid9.hOffset, Grid9.vOffset);
					break;
				case 10:
					Piece12.moveTo(Grid10.hOffset, Grid10.vOffset);
					break;
				case 11:
					Piece12.moveTo(Grid11.hOffset, Grid11.vOffset);
					break;
				case 12:
					Piece12.moveTo(Grid12.hOffset, Grid12.vOffset);
					break;
			} // switch()
			break;
	} // switch()
	for (i=0; i<maxPieces; i++) {
		if (boardPositions[i] == currentPieceNumber) {
			boardPositions[i]=0;

		}
	}
	boardPositions[currentGridNumber-1]=currentPieceNumber;
	print("boardPositions="+boardPositions);
	currentHighlightedPiece=0;
	currentHighlightedGrid=0;
	var vacantSpot=false;
	for (j=0; j<maxPieces; j++) {
		if (boardPositions[j] == 0) {
			vacantSpot=true;
			break;
		}
	}
	if (vacantSpot == false) {
		var wrongPiecePosition=false;
		for (c=0; c<maxPieces; c++) {
			if (boardPositions[c] != c+1) {
				wrongPiecePosition=true;
				break;
			}
		}
		if (wrongPiecePosition == false) {
			endPuzzle();
		}
		else {
			// Continue. Puzzle not correctly solved.
		}
	}
} // movePiece()

